# EKKINISH (Edo theoritika den allazoyme kamia grammi kodika)
from __future__ import division
from visual import *
from physutil import *
import csv

# Kodikas gia tin grafiki anaparastasi toy montelou
# ===========================================

# Arxikopoiisi parathirou gia anaparastasi
graph = PhysGraph(1)
# Arxikopoiisi parathirou gia optikopoiisi
scene = display(width = 640, height = 480, background = color.white, range = 3.5, center=vector(0,-2,0), title = "VPython Test")
# Dimiourgia antikeimenou gia montelopoiisi
ball = sphere(color = color.blue, radius = 0.22)
# Dimiourgia tis troxias poy diagrafei to antikeimeno
trail = curve(color = color.green, radius = 0.02)
# Dimiourgia antikeimenou poy anaparista to antikeimeno tou peiramatos
origin = sphere(pos=vector(0,0,0), color = color.yellow, radius = 0.02)
# Dimiourgia dianismaton
arrow1=arrow(pos=ball.pos,axis=vector(0,0,0),color = color.yellow)
arrow2=arrow(pos=ball.pos,axis=vector(0,0,0),color = color.blue)


# IDIOTITES SYSTHMATOS KAI ARXIKES PROYPOTHESEIS
# ===========================================

# Maza systimatos
# Tin parakato grammi mporeite na tin allajete
ball.m =0.024

# Arxikes proypotheseis
# Tis parakato treis grammes mporeite na tis allajete
ball.pos = vector(0,-0.005,0)
ball.vel = vector(0,-0.667,0)
ball.vel.mag = math.pow(ball.vel.x,2) + math.pow(ball.vel.y,2) + math.pow(ball.vel.z,2)
vhat = ball.vel/ball.vel.mag
t = 0  # o xronos enarjis tou peiramatos


# Alles arxikopoiiseis
# ==========================================
#
# Bima xronou dt
# Tin parakato grammi mporeite na tin allajete
deltat = 0.001

# Arxikopoiisi allelepidraseon
#
# Epitaxynsi tis barititas g,
# Thetoume tin timi tis statheras konta stin epifaneia tis gis
g=9.8

# monadiaio dianisma gia ton ajona ton y
jhat=vector(0,1,0)

# stathera aposbesis
b=0.01006



# PROERETIKA: Problepsis toy montelou apothikeyontai se arxeio me proektasi .csv 
# Gia na ginei xrisi autis tis dinatotitas afaireite to # apo tin epomeni grammi 
outputfile = open('pythonTest.csv', 'wb') # Kathorismos toy onomatos toy arxeioy
                                          # Ean to arxeio yparxei tha diagrafei                            
DataWriter = csv.writer(outputfile, delimiter=',', quotechar='|', quoting=csv.QUOTE_MINIMAL) # Dimioyrgia writer antikeimenou
DataWriter.writerow(['Time (s)','Position (m)']) # Eggrafi epikefalidas gia xrono, thesi kai taxythta


# BROXOS EPANALIPSIS (Problepsi kinisis kai optiki anaparastasi)
# ===========================================
while t < 0.7:
    # Ypologismos tis synistamenis dinamis
    # Tin parakato grammi mporeite na tin allajete
    W = -ball.m*g*jhat
    Fd = -b*ball.vel.mag*ball.vel.mag*vhat
    Fnet = W + Fd
    # Deyteros nomos tou Neytona (problepsi-ypologismos tis taxytitas)
    # Tin parakato grammi mporeite na tin allajete
    ball.vel = ball.vel +  (Fnet/ball.m)*deltat
    # problepsi-ypologismos tis thesis
    # Tin parakato grammi mporeite na tin allajete
    ball.pos = ball.pos + ball.vel*deltat
    # Auksisi toy xronoy kata dt
    t = t + deltat


    
    # Enimerosi tis troxias toy antikeimenou
    trail.append(pos = ball.pos)
    # Dimiourgia tis grafikis parastasis thesis-xronou
    # Tin parakato grammi mporeite na tin allajete
    graph.plot(t,ball.pos.y)
    # Sxeidiasmos dianismaton poy anaparistoun dynameis
    # Tin parakato grammi mporeite na tin allajete
    arrowscale = 10 # kathorizei to mikos ton belon poy paristanoun dianysmata
                    # gia dinami 1 to arrowscale anaparista
                    # to mikos toy dianismatos se metra 
    arrow1.pos = ball.pos
    arrow1.axis = W*arrowscale
    arrow2.pos = ball.pos
    arrow2.axis = Fd*arrowscale

    # Gia na epitaxynetai i na epibradinetai tin ektelesi toy programmatos
    # Tin parakato grammi mporeite na tin allajete (megalyteros arithmos, grigoroteri ektelesi)
    rate(200)

    # Gia na epitaxynetai i na epibradinetai tin ektelesi toy programmatos
    # Tin parakato grammi mporeite na tin allajete (megalyteros arithmos, grigoroteri ektelesi)
    DataWriter.writerow([str(t),str(ball.pos.y)])


print(t,ball.pos)

# PROERETIKA: Problepsis toy montelou apothikeyontai se arxeio me proektasi .csv 
# Gia na ginei xrisi autis tis dinatotitas afaireite to # apo tin epomeni grammi 
outputfile.close()
